function MigracaoAFController(ScreenService, templateManager, General, maskEngine, ZhUtil, MessageService, ZHPromise) {
    
    const self = this;
    let paramVrUnit;

    this.getFilialdestino = function(field){
        field.dataSourceFilter = [
			{'name': 'P_CDGRUPFILI', 'operator': '=', 'value': field.widget.currentRow.CDGRUPFILI},
			{'name': 'P_CDCENTCMP',  'operator': '=', 'value': getLocalVar('CDFILCENTCMP')},
			{'name': 'P_CDOPERADOR',  'operator': '=', 'value': getLocalVar('CDOPERADOR')},
			{'name': 'NRORG',  'operator': '=', 'value': getLocalVar('NRORG')}
		];
		field.reload();
    };
    
    this.openFiltro = function(widget){
        const widgetFiltro = widget.container.getWidget('sup98000_filtroMigracaoAF');
        
        MessageService.getMessageByCode("cmp#VR_UNIT").then(function(vrUnit) {
            paramVrUnit = {
                PARAMS: '\"'.concat(vrUnit, '\"')
            };
            General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
                setLocalVar('NMFILCENTCMP', response.dataset.data.NMFILCENTCMP);
                setLocalVar('CDFILCENTCMP', response.dataset.data.CDFILCENTCMP);
                
                ScreenService.openPopup(widgetFiltro);
                
            }, function(error) {
    			return MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
    		});
        });
    };
    
    this.setProdFinalMin = function(widget){
        let nmprodfin = widget.getField('NMPRODFIN');
        
        changeProduct(widget);
        if(widget.currentRow.CDPRODINI){
            nmprodfin.dataSourceFilter = [
                {"name": "CDARVPROD",    "value": widget.currentRow.CDPRODINI, "operator": ">="},
                {"name": "NRORG",       "value": getLocalVar('NRORG'),         "operator": "="},
                {"operator": "ORDER_BY", "name": [{"name": "CDARVPROD", "direction": "ASC"}]}
            ];
        } else {
            nmprodfin.dataSourceFilter = [
                {"name": "NRORG",       "value": getLocalVar('NRORG'),         "operator": "="},
                {"operator": "ORDER_BY", "name": [{"name": "CDARVPROD", "direction": "ASC"}]}
            ];  
        }
        nmprodfin.reload();
    };
    
    this.fecharFiltro = function(widget){
        ScreenService.closePopup();
        ScreenService.closeSwipe(0);
        widget.activate();
    };
    
    function validaProduto(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("cmp#PRODUTO_INICIAL_MENOR_IGUAL_FINAL", {}, {
                type: 'INFORMATION'
            });
            return false;
        }
        return true;
    }
    
    function changeProduct(widget) {
        if (widget.getField('NMPRODINI').value() || widget.getField('NMPRODFIN').value()){
            widget.getField('NMPRODINI').validations = { "required" : true };
            widget.getField('NMPRODFIN').validations = { "required" : true };
        } else {
            widget.getField('NMPRODINI').validations = {};
            widget.getField('NMPRODFIN').validations = {};
        }    
    }
    
    this.changeRequired = function(widget){
        changeProduct(widget);
    };
    
    this.getFornecedoresGrid = function(widget){
    	const widgetForn = widget.container.getWidget('sup98000_gridFornecedorAF');
    	const widStripe  = templateManager.container.getWidget('sup98000_stripeWidget');
        
        if (widget.isValid()) {
    	    if(validaProduto(widget.currentRow.NMPRODINI, widget.currentRow.NMPRODFIN)){
    	        setDtAutoForn(widget);
                setDtProgEntAF(widget);
                setFiltroProduto(widget);
                        
                setLocalVar('IDTPGERARUP', widget.currentRow.exibeRupturaOL);
        	    setLocalVar('CDPRODINI', widget.currentRow.CDPRODINI);
            	setLocalVar('CDPRODFIN', widget.currentRow.CDPRODFIN);
            	setLocalVar('DTPROGENTAFINI', widget.currentRow.DTPROGENTAFINI);
        		setLocalVar('DTPROGENTAFFIN', widget.currentRow.DTPROGENTAFFIN);
                
                widget.currentRow.CDFILCENTCMP = getLocalVar('CDFILCENTCMP');
                General.callRestEngine('cmp_fornecimento_migracaoAF#/migracaoAF', 'Row', widget.currentRow).then(function(callback) {
    			    widgetForn.dataSource.data = callback.dataset.resposta;
    			    
    			    widStripe.currentRow.NMGRUPFILI_STRIPE  = widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : "Não informado.";
    			    widStripe.currentRow.RUPTURA_STRIPE     = widget.currentRow.exibeRupturaOL === "S" ? "Sim" : "Não";
    			    widStripe.currentRow.DTAF_STRIPE        = widget.currentRow.DTAUTFINI && widget.currentRow.DTAUTFFIN ? widget.currentRow.DTAUTFINI + " a " + widget.currentRow.DTAUTFFIN : "Não informado.";
    			    widStripe.currentRow.DTENTREGA_STRIPE   = widget.currentRow.DTPROGENTAFINI && widget.currentRow.DTPROGENTAFFIN ? widget.currentRow.DTPROGENTAFINI + " a " + widget.currentRow.DTPROGENTAFFIN : "Não informado.";
                    if(widget.currentRow.CDPRODINI && widget.currentRow.CDPRODFIN){
                        let mask = {
                			type: "fix",
                			params: {
                				mask: getLocalVar('CDPICTPROD')
                			}
                		};
                		widStripe.currentRow.PRODUTO_STRIPE = Util.applyMask(widget.currentRow.CDPRODINI, mask, maskEngine, ZhUtil) + " - " + widget.currentRow.NMPRODINI + " a " + Util.applyMask(widget.currentRow.CDPRODFIN, mask, maskEngine, ZhUtil) + " - " + widget.currentRow.NMPRODFIN;
                    } else {
                        widStripe.currentRow.PRODUTO_STRIPE = "Não informado.";    
                    }
                    
    			    ScreenService.closePopup();
    		        widgetForn.reload();
    				widgetForn.activate();
                });   
    	    }
		}
    };
    
    var setDtAutoForn = function(widget){
        if(widget.currentRow.INTERVAL_DTAUTOFORN) {
            widget.currentRow.DTAUTFINI = widget.currentRow.INTERVAL_DTAUTOFORN.start;
            widget.currentRow.DTAUTFFIN = widget.currentRow.INTERVAL_DTAUTOFORN.end;
        } else {
            widget.currentRow.DTAUTFINI = null;
            widget.currentRow.DTAUTFFIN = null;
        }    
    };
    
    var setDtProgEntAF = function(widget){
        if(widget.currentRow.INTERVAL_DTPROGENTAF) {
            widget.currentRow.DTPROGENTAFINI = widget.currentRow.INTERVAL_DTPROGENTAF.start;
            widget.currentRow.DTPROGENTAFFIN = widget.currentRow.INTERVAL_DTPROGENTAF.end;
        } else {
            widget.currentRow.DTPROGENTAFINI = null;
            widget.currentRow.DTPROGENTAFFIN = null;
        }    
    };
    
    var setFiltroProduto = function(widget) {
        if(!widget.currentRow.CDPRODINI){
            widget.currentRow.CDPRODINI = null;
        }
        if(!widget.currentRow.CDPRODFIN){
            widget.currentRow.CDPRODFIN = null;
        }
    };
    
    this.openProdutoAF = function(widget){
        var widgetTabbed  = widget.container.getWidget('sup98000_tabbedProdutoAF');
        var widgetProdutoAF = widget.container.getWidget('sup98000_gridProdutoAF');
        widgetProdutoAF.dataSourceFilter = dsFilterProdutoAF(widget);
		widgetProdutoAF.reload().then(function(callback){
			ScreenService.openSwipe(widgetTabbed).then(function() {
				widgetProdutoAF.activate();
			});
		});
    };
    
    this.selectRowProdutoAF = function(widget){
        var widgetFornAF = widget.container.getWidget('sup98000_gridFornecedorAF');
        var widgetProdAF = widget.container.getWidget('sup98000_gridProdutoAF');
        if(widgetProdAF && widgetProdAF.dataSource.data && widgetProdAF.dataSource.data.length){
            widgetProdAF.dataSource.data.forEach(function(row){
                row.__isSelected = true;
            });
        }
        this.fechaSwipe(widgetFornAF);
    };
    
    var dsFilterProdutoAF = function(widget){
        var widgetFiltro = widget.container.getWidget('sup98000_filtroMigracaoAF');
        var filterProd = [
			{name: "P_CDFILDEST",       value: widget.currentRow.CDFILDEST            || '', operator: "="},
			{name: "P_CDFILLANC",       value: widget.currentRow.CDFILLANC            || '', operator: "="},  
			{name: "P_NRAUTOFORN",	    value: widget.currentRow.NRAUTOFORN           || '', operator: "="},  
			{name: "P_CDPRODINI",	    value: widgetFiltro.currentRow.CDPRODINI      || '', operator: "="},
			{name: "P_CDPRODFIN",	    value: widgetFiltro.currentRow.CDPRODFIN	  || '', operator: "="},
			{name: "P_DTPROGENTAFINI",	value: widgetFiltro.currentRow.DTPROGENTAFINI || '', operator: "="},
			{name: "P_DTPROGENTAFFIN",	value: widgetFiltro.currentRow.DTPROGENTAFFIN || '', operator: "="},
			{name: "P_IDTPGERARUP",	    value: getLocalVar('IDTPGERARUP')             || '', operator: "="},
			{name: "NRORG",             value: getLocalVar('NRORG')	                  || '', operator: "="}
		];
		return filterProd;    
    };
    
    this.fechaSwipe = function(widgetActivate){
        ScreenService.closeSwipe();
        widgetActivate.activate();
        widgetActivate.redraw();
    };
    
    this.cancelaMigracao = function(widget){
        ScreenService.closeSwipe();
        widget.container.getWidget(widget.container.getWidget('sup98000_gridConfirmaMigracaoAF').widgetOrigem).activate();
    };
    
    this.backToList = function(widget){
		 widget.list();
		 ScreenService.closeSwipe();
		 widget.activate();
	};
	
	this.setConfirmaMigracao = function(widget){
	    var widgetForn  = widget.container.getWidget('sup98000_pesquisaForn');
        widgetForn.currentRow = {};
        widget.container.getWidget('sup98000_gridConfirmaMigracaoAF').widgetOrigem = widget.name;
        var fieldForn = widgetForn.getField('NMFANTFORN');
        fieldForn.dataSourceFilter = dsFilterPesqForn(widget); 
		fieldForn.reload().then(function(callback){
			ScreenService.openPopup(widgetForn);
		});
    };
    
    var dsFilterPesqForn = function(widget){
        var filterForn = [
			{name: "P_CDFILIAL", value: getLocalVar('CDFILCENTCMP') || '', operator: "="},
			{name: "NRORG",      value: getLocalVar('NRORG') || '', operator: "="}
		];
		return filterForn;
    };
    
    var preencheRowFiltro = function(rows, widget){
        rows.forEach(function(row) {
            row.IDTPGERARUP    = getLocalVar('IDTPGERARUP');
            row.CDPRODINI      = getLocalVar('CDPRODINI');
            row.CDPRODFIN      = getLocalVar('CDPRODFIN');
            row.DTPROGENTAFINI = getLocalVar('DTPROGENTAFINI');
            row.DTPROGENTAFFIN = getLocalVar('DTPROGENTAFFIN');
            row.CDOPERADOR     = getLocalVar('CDOPERADOR');
            row.CDFILCENTCMP   = getLocalVar('CDFILCENTCMP');
            row.CDOPERADOR     = getLocalVar('CDOPERADOR');
            
            row.NEW_CDFORNECED     = widget.currentRow.CDFORNECED;
            row.NEW_NRINSJURFORN   = widget.currentRow.NRINSJURFORN;
            row.NEW_IDTPIJURFORN   = widget.currentRow.IDTPIJURFORN;
            row.NEW_NMFANTFORN     = widget.currentRow.NMFANTFORN;
            row.NEW_NMRAZSOCFORN   = widget.currentRow.NMRAZSOCFORN;
            row.NEW_IDGERAFDTENT   = widget.currentRow.IDGERAFDTENT;
            
            widget.container.getWidget('sup98000_gridFornecedorAF').getField('IDUTLPROCMPAF').dataSource.data.forEach(function(p){
				if(p.CDFILIAL == getLocalVar('CDFILCENTCMP')){
					row.IDUTLPROCMPAF  = p.IDUTLPROCMPAF;	
				}	
			});
        });
        return rows;
    };
    
    this.setCriaConfirmacao = function(widget){
        if(widget.currentRow.NMFANTFORN.length > 0){
            var widgetFornAF = widget.container.getWidget('sup98000_gridFornecedorAF');
            var widgetProdAF = widget.container.getWidget('sup98000_gridProdutoAF');
            var widgetTabbed = widget.container.getWidget('sup98000_tabbedConfirmaMigracaoAF');
            var widgetConfAF = widget.container.getWidget('sup98000_gridConfirmaMigracaoAF');
            var allProducts = widgetFornAF.isLastActiveWidget();
            var row;
            var itens;
            
            ScreenService.closePopup();
            if(allProducts){
                itens = widgetFornAF.dataSource.getCheckedRows();
                itens = preencheRowFiltro(itens, widget);
    
            } else{
                itens = widgetProdAF.dataSource.getCheckedRows();
                itens = preencheRowFiltro(itens, widget);
                itens.forEach(function(item){
                    item.__isSelected   = false;
                    item.DTAUTOFORN     = widgetFornAF.currentRow.DTAUTOFORN;
                    item.IDTIPOEMITAF   = widgetFornAF.currentRow.IDTIPOEMITAF;
                    item.CDEMPRESA      = widgetFornAF.currentRow.CDEMPRESA;
                    item.IDAFOPERLOG    = widgetFornAF.currentRow.IDAFOPERLOG;
                    item.CDFORNECED_OLD = widgetFornAF.currentRow.CDFORNECED;
                    item.CDFORNOPELOG   = widgetFornAF.currentRow.CDFORNOPELOG;
                    item.CDFILIOPELOG   = widgetFornAF.currentRow.CDFILIOPELOG;
                    item.IDTIPOLANCAF   = widgetFornAF.currentRow.IDTIPOLANCAF;
                });
                
            }
            
            row = [ [ allProducts ], itens ];
            
            General.callRestEngine('cmp_fornecimento_migracaoAF#/confirmaMigracao', 'DataSet', row).then(function(callback) {
        		widgetConfAF.dataSource.data = callback.dataset.resposta;
        		widgetConfAF.reload();
        		ScreenService.openSwipe(widgetTabbed).then(function() {
    				$('.swipe-tip').before('<div style="position: absolute;left: 0;top: 0;bottom: 0;right: 0;opacity: 0.6;transform: translate(-100%, 0);-webkit-transform: translate(-100%, 0);"></div>');
    				widgetConfAF.activate();  
    			});
    		});
        }
    };
    
    this.editarConfMigracao = function(widget){
		General.edit(widget);
    	var fieldFornOL = widget.container.getWidget('sup98000_gridFornecedorAF').getField('CDFILIOPELOG');
    	fieldFornOL.dataSourceFilter = dsFilterPesqFornecedorOL(widget); 
		fieldFornOL.reload().then(function(callback){
		    var fieldProduto = widget.getField('NMPRODUTO');
		    fieldProduto.dataSourceFilter = dsFilterPesqProduto(widget, callback, null); 
		    fieldProduto.reload().then(function(callback){
		        self.getMarcaProduto(widget);
		    });
		});
    };
    
    this.cancelConfMigracao = function(args){
        var widget = args.owner.widget;
        General.backOrCancel(args);
        this.fechaSwipe(widget.container.getWidget('sup98000_gridConfirmaMigracaoAF'));
    };
    
    var dsFilterPesqFornecedorOL = function(widget){
        var filter = [
			{name: "P_CDFORNOPELOG", value: widget.currentRow.CDFORNECED || '', operator: "="},
			{name: "P_CDFILDEST", value: widget.currentRow.CDFILDEST || '', operator: "="},
			{name: "NRORG",      value: getLocalVar('NRORG') || '', operator: "="}
		];
		return filter;
    };
    
    var dsFilterPesqProduto = function(widget, callback, cdarvprod){
        var fornOpeLog = null;
        if(callback.dataset.sup98000_fornecedorOL.length > 0){
            fornOpeLog = callback.dataset.sup98000_fornecedorOL[0].CDFORNOPELOG;   
        }
        var filter = [
			{name: "P_CDFILCENTCMP", value: getLocalVar('CDFILCENTCMP') || '', operator: "="},
			{name: "P_CDPRODOLD", value: widget.currentRow.CDPRODUTO_OLD || '', operator: "="},
			{name: "P_CDFORNECED", value: widget.currentRow.CDFORNECED || '', operator: "="},
			{name: "P_CDFORNOPELOG", value: fornOpeLog || '', operator: "="},
			{name: "NRORG",      value: getLocalVar('NRORG') || '', operator: "="}
		];
		return filter;
    };
    
    this.getMarcaProduto = function(widget){
		var fieldMarca = widget.getField('NMMARCA');
	    fieldMarca.dataSourceFilter = dsFilterPesqMarcaProduto(widget); 
	    fieldMarca.reload().then(function(callback){
	        if(widget.currentRow.CDARVPROD != '' && widget.currentRow.CDPRODUTO != widget.currentRow.CDPRODUTO_OLD){
	        	self.NovoPreco(widget);
	    	}   
	    });
    };
    
    var dsFilterPesqMarcaProduto = function(widget){
        var filter = [
			{name: "P_CDARVPROD", value: widget.currentRow.CDARVPROD || '', operator: "="},
			{name: "NRORG",      value: getLocalVar('NRORG') || '', operator: "="}
		];
		return filter;
    };
    
    this.changeDtEntrega = function(widget){
        if(widget.currentRow.DTPROGENTAF != '' && widget.currentRow.DTPROGENTAF != widget.currentRow.DTPROGENTAF_OLD){
            validaDtEntrega(widget);
        }
    };
    
    this.NovoPreco = function(widget){
	    widget.dataSource.data.forEach(function(value) {
            value.CDFORNECED  = widget.currentRow.CDFORNECED;
            value.CDFILDEST   = widget.currentRow.CDFILDEST;
            value.CDPRODUTO   = widget.currentRow.CDPRODUTO;
            value.CDMARCA     = widget.currentRow.CDMARCA;
            value.DTPROGENTAF = widget.currentRow.DTPROGENTAF;
        });
    	General.callRestEngine('cmp_fornecimento_migracaoAF#/novoPreco', 'DataSet', widget.dataSource.data).then(function(callback) {
    	    if(callback.dataset.resposta.length > 0){
    	        widget.currentRow.VRPREUNIAF = callback.dataset.resposta[0].VRPRECUNIITM;    
    	    } else {
    	        widget.currentRow.VRPREUNIAF = 0;    
    	    }
        });
    };
    
    var validaDtEntrega = function(widget){
        const dataEntrega = widget.currentRow.DTPROGENTAF;
        const prtDataEntrega = dataEntrega.split("/");
        const widgetMigracao = widget.container.getWidget('sup98000_gridConfirmaMigracaoAF');
      
        if(dataEntrega < new Date(prtDataEntrega[2], prtDataEntrega[1] - 1, prtDataEntrega[0])) {
            MessageService.showMessageByCode("cmp#DELIVERY_DATE_GREATER_EQUAL_CURRENT", {}, {
                type: 'INFORMATION'
            });
        } else {
            const params = {
                PARAMS: widget.currentRow.DTPROGENTAF
            };

            MessageService.confirmMessageByCode("cmp#CHANGE_OTHER_DELIVERES", params, 'question').then(function(success) {
                widgetMigracao.dataSource.data.forEach(function(af){
                    af.DTPROGENTAF = widget.currentRow.DTPROGENTAF;
                    self.NovoPreco(widget);
                });
            });
        }
    };
    
    function validaVrUnit(rows) {
        let result = true;
        rows.forEach(function(row) {
            row.VRPREUNIAF = General.valueToFloat(row.VRPREUNIAF ? row.VRPREUNIAF : 0);
            if (parseFloat(row.VRPREUNIAF) == 0) {
                result = false;
            }
        });
        return result;
    }
    
    function validaDataEntrega(rows){
        const currentDate = moment(moment(), 'L').format('L');
        let result = true;

        rows.forEach(function(row){
            if(currentDate > moment(row.DTPROGENTAF, 'L').format('L')){
                result = false;
            }
        });
        return result;
    }
    
    function validaEntregaPorFornecedor(rows){
        const firstDate = moment(rows[0].DTPROGENTAF, 'L').format('L');
        let result = true;

        if(rows.length > 1){
            rows.forEach(function(row){
                if(row.IDGERAFDTENT == 'S'){
                    if(moment(row.DTPROGENTAF, 'L').format('L') != firstDate){
                        result = false;
                    }
                }
            });
        }
        return result;
    }
    
    function verificaDataIgual(rows) {
        let count = 0;
        
        rows.forEach(function(row){
            if(row.DTPROGENTAF == row.DTPROGENTAF_OLD){
                count = count + 1;    
            }
        });
        return count == 0;
    }
    
    function validaQuantidade(rows) {
        let result = true;
        
        rows.forEach(function(row){
            row.QTPROGENTAF = General.valueToFloat(row.QTPROGENTAF ? row.QTPROGENTAF : 0);
            if(parseFloat(row.QTPROGENTAF) == 0){
                result = false;
            }    
        });
        return result;
    }
    
    this.migracaoAF = function(widget){
        const rows = widget.dataSource.data;
        
        if(!validaVrUnit(rows)) {
            MessageService.showMessageByCode("cmp#VALUE_FIELD_N_INFORMED", paramVrUnit, {type: 'ERROR'});
            return false;
        }
        
        if(!validaDataEntrega(rows)) {
            MessageService.showMessageByCode("cmp#DELIVERY_DATE_GREATER_EQUAL_CURRENT", {}, {type: 'ERROR'});
            return false;
        }
        
        if(!validaEntregaPorFornecedor(rows)) {
            MessageService.showMessageByCode("cmp#SOMENTE_UMA_DTPROGENTAF", {}, {type: 'ERROR'});
            return false;
        }
        
        if(!validaQuantidade(rows)) {
            MessageService.showMessageByCode("cmp#ONE_OR_MORE_QT_ZERO", {}, {type: 'ERROR'});
            return false;    
        }
        
        if(!verificaDataIgual(rows)) {
            MessageService.confirmMessageByCode("cmp#DELIVERY_DATE_EQUAL_ORIGINAL", 'question').then(function(success) {
                self.inLineMigracaoAF(widget);
            });    
        } else {
            self.inLineMigracaoAF(widget);
        }
    };
    
    this.inLineMigracaoAF = function(widget){
        const widgetMigracao = widget.container.getWidget('sup98000_gridConfirmaMigracaoAF');
        const widgetPesqForn = widget.container.getWidget('sup98000_pesquisaForn');
        const widgetResult = widget.container.getWidget('sup98000_resultado');
        const rows = widgetMigracao.dataSource.data;
        const arrayError = preencheArrayError();
        let promises = [];
        
        if(widget.isValid()){
            arrayError.forEach(function(row) {
                var messagePromise = MessageService.getMessageByCode('cmp#'.concat(row.codeError)).then(function(message) {
                    row.msgError = message;
                });
                promises.push(messagePromise);            
            });
            
            ZHPromise.all(promises).then(function() {
                setTimeout(function() {
                    let params = {
                        'MESSAGES': arrayError,
                        'PRODUTOS': rows,
                        'FORNECEDOR': widgetPesqForn.currentRow
                    };

                    General.callRestEngine('cmp_fornecimento_migracaoAF#/finalizaMigracao', 'DataSet', params).then(function(callback) {
                        if(callback.dataset.resposta.length > 0) {
                            if(callback.dataset.resposta[0].DSERROR != null){
                                var widgetResult = widget.container.getWidget('sup98000_resultado');
                                var arrayError = preencheArrayError();
                                callback.dataset.resposta.forEach(function(error){
                                    arrayError.forEach(function(msg){
                                        if(msg.CODE == error.DSERROR){
                                            error.DSERROR = msg.DSERROR;
                                        }
                                    });
                                });
                                widgetResult.dataSource.data = callback.dataset.resposta;
                                widgetResult.widgetOrigem = widgetMigracao;
                                ScreenService.openPopup(widgetResult);
                                widgetResult.activate();
                            } else {
                                if(callback.dataset.resposta[0] != '          '){
                                    const params = {
                                        PARAMS: callback.dataset.resposta[0]
                                    };

                                    MessageService.successNotificationByCode("cmp#SUCCESS_MIGRACAO", params).then(function(){
                                        ScreenService.closeSwipe(0);
                                        self.getFornecedoresGrid(widget.container.getWidget('sup98000_filtroMigracaoAF'));    
                                    });
                                    

                                }
                            }
                        }
                    });
                }, 350);
            });
        }
    };
    
    var preencheArrayError = function(){
        const arrayError = [
            {'codeError': 'ProdNCad'},
            {'codeError': 'Prod_est'},
            {'codeError': 'ProdEstoInval'},
            {'codeError': 'PesqMarcaProd'},
            {'codeError': 'Produto_Inativo'},
            {'codeError': 'Marc_NQualif'},
            {'codeError': 'N_MarcProd'},
            {'codeError': 'N_ProdFornComp'},
            {'codeError': 'N_RefoReg'},
            {'codeError': 'MarcaObrig'},
            {'codeError': 'MarcaPref'},
            {'codeError': 'RestricMarca'},
            {'codeError': 'ProdPref'},
            {'codeError': 'DT_Prod_Inv'},
            {'codeError': 'PeriForn'},
            {'codeError': 'ProdComprador'}
        ];
        return arrayError;
    };
    
    this.fechaPopup = function(widget){
        ScreenService.closePopup();
        widget.widgetOrigem.activate();
    };
    
    this.saveRowOnForm = function(args){
        if(args.owner.widget.isValid()) {
            General.saveRow(args, true);
        }   
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MigracaoAFController', MigracaoAFController);
});    