var cmp07400controle_de_alteracao_solicitacao_comprasController = function(General,ScreenService,templateManager, ZhFilterPreferences, Utilities) {
	
	this.setFilterInitValues = function(widget) {
		var filterRow = {
			"NMFILIAL": getLocalVar('NMFILIAL'),
			"CDFILIAL": getLocalVar('CDFILIAL'),
		    "DTENTREGA": {
		    	"start": moment().format('L'),
		        "end": moment().format('L'),
		    },
		    "DTSOLICITACAO": {
		    	"start": moment().format('L'),
		    	"end": moment().format('L')
		    }
		};
		
		ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    };
    
    this.widgetOnEnter = function(widget) {
        //widget.getField("NMFILIAL").filterProperties.readOnly = (window.projectCorp) ? false : true;
        widget.getField("NMFILIAL").filterProperties.readOnly = false;
        this.createDsFilterUS(widget.getField('NMFILIAL'));
    	var filterRow = {
    	    DTSOLICITACAO : {
    	        'formattedStart': moment().format('DD/MM/YYYY'),
    	        'formattedEnd': moment().format('DD/MM/YYYY'),
    	        'start': moment().format('DD/MM/YYYY'),
    	        'end': moment().format('DD/MM/YYYY')
    	    },
    	    DTENTREGA : {
    	        'formattedStart': moment().format('DD/MM/YYYY'),
    	        'formattedEnd': moment().format('DD/MM/YYYY'),
    	        'start': moment().format('DD/MM/YYYY'),
    	        'end': moment().format('DD/MM/YYYY')
    	    }
    	    
        };

    	Utilities.startFilter(widget, filterRow);
    };

//set values in stripe
	this.setStripe = function (widget) {
		var filterRow = angular.copy(widget.appliedFilter.FILTER_ROW);
		var stripe = widget.container.getWidget('stripe');
		
		stripe.currentRow.UNIDADESOL	 = Array.isArray(filterRow.NMFILIAL) ? filterRow.NMFILIAL.join(', ') : ScreenService.i18("Todas");
		stripe.currentRow.SOLICITACAO 	 = Array.isArray(filterRow.NRSOLICITA) ? filterRow.NRSOLICITA.join(', ') : ScreenService.i18("Todas");
		stripe.currentRow.DTENTREGASTRIPE= (filterRow.DTENTREGA.start && filterRow.DTENTREGA.end)? filterRow.DTENTREGA.formattedStart + ' - ' + filterRow.DTENTREGA.formattedEnd : ScreenService.i18("Todas"); 
		stripe.currentRow.DTSOLISTRIPE	 = (filterRow.DTSOLICITACAO.start && filterRow.DTSOLICITACAO.end) ? filterRow.DTSOLICITACAO.formattedStart + ' - ' + filterRow.DTSOLICITACAO.formattedEnd : ScreenService.i18("Todas");
		
		if(widget._filterInfo && widget._filterInfo[0] && widget._filterInfo[0].value === ""){
			widget._filterInfo[0].value = ScreenService.i18("Todas");
		}
		// widget needs to be activated to show checked event
		widget.reload().then(function(success){
			widget.activate();
		});
	};

//validate checkbox for all/list
    this.selectTodosLista = function (field) {
		if(field.checked) {
			field.widget.getField(field.name.substring(2,field.name.length)).clearValue();
			field.widget.getField(field.name.substring(2,field.name.length)).readOnly = true;
			field.widget.getField(field.name.substring(2,field.name.length)).validations = {};
		} else {
			field.widget.getField(field.name.substring(2,field.name.length)).readOnly = false;
			field.widget.getField(field.name.substring(2,field.name.length)).validations = { "required": {} };
		}
	};
	
	
	this.setTodas = function (field) {
		if(field.value()===null){
			field.setValue(" ");
			field.mask ={};
		}
	};
//validate filter (grid) confirmation
	this.filterSolicitaGrid = function(args) {
		var filterRow = angular.copy(args.e.preference.FILTER_ROW);

		// filterRow.CDFILIAL = getLocalVar('CDFILIAL');
		
		/* 
		Devido a execução assíncrona do 'then' e a necessidade do P_NRLISTAFIL,
		foi necessário forçar a inclusão do CUSTOM_FILTER_ROW para impedir que
		o filtro do Zeedhi use os dados do FILTER_ROW para executar o dataSource 
		(ocasionava erro na chamada caso passasse) e forçar a execução do filtro
		através do dataSourceFilter.A feta a forma de recuperar os dados no 
		this.setStripe
		*/
		
		if(Array.isArray(filterRow.NMFILIAL) && filterRow.NMFILIAL.length){
			filterRow.CDFILIAL = filterRow.NMFILIAL.join('_');
		}else{
			filterRow.CDFILIAL = 'T';
		}
		
		// args.e.preference.CUSTOM_FILTER_ROW = {};
		
		filterRow.NMGRUPFILI = filterRow.CDGRUPFILI ? filterRow.CDGRUPFILI : null;
		return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/setgrid','Row',filterRow).then(function(callback) {
		//	var DTSOLICITACAO = typeof filterRow.DTSOLICITACAO === "undefined" || typeof filterRow.DTSOLICITACAO.formattedStart === "undefined" ? true : false;
		//	var DTENTREGA = typeof filterRow.DTENTREGA === "undefined" || typeof filterRow.DTENTREGA.formattedStart === "undefined" ? true : false;
		
		var P_DTENTRINI = filterRow.DTENTREGA.start ?  filterRow.DTENTREGA.start : null ;
		var P_DTENTRFIM = filterRow.DTENTREGA.end ?  filterRow.DTENTREGA.end : null ;
		var P_DTSOLINI = filterRow.DTSOLICITACAO.start ?  filterRow.DTSOLICITACAO.start : null ;
		var P_DTSOLFIM = filterRow.DTSOLICITACAO.start ?  filterRow.DTSOLICITACAO.end : null ;
		var P_TENTREGA = (filterRow.DTENTREGA.start && filterRow.DTENTREGA.end) ?  null : 'T' ;
		var P_TSOLICITA = (filterRow.DTSOLICITACAO.start && filterRow.DTSOLICITACAO.end) ?  null : 'T' ;
			args.owner.dataSourceFilter = [
				{
					'name': 'P_NRLISTAFIL',
					'operator': '=',
					'value': callback.dataset.NrLista[0]
				},
				{
					'name': "P_DTENTRINI",
					'operator': '=',
					'value':  P_DTENTRINI
				},
				{
					'name': "P_DTENTRFIM",
					'operator': '=',
					'value': P_DTENTRFIM
				},
				{
					'name': "P_TENTREGA",
					'operator': '=',
					'value': P_TENTREGA 
				},
				{
					'name': "P_NRSOLICMP",
					'operator': '=',
					'value': Array.isArray(filterRow.NRSOLICITA) ? filterRow.NRSOLICITA.join('_') : null
				},
				{
					'name': "P_TNRSOLICMP",
					'operator': '=',
					'value': (filterRow.NRSOLICITA !== undefined && filterRow.NRSOLICITA.length > 0) ? '' : 'T'
				},
				{
					'name': "P_DTSOLINI",
					'operator': '=',
					'value': P_DTSOLINI
				},
				{
					'name': "P_DTSOLFIM",
					'operator': '=',
					'value': P_DTSOLFIM
				},
				{
					'name': "P_TSOLICITA",
					'operator': '=',
					'value': P_TSOLICITA
				},
				{
					'name': 'NRORG',
					'operator': '=',
					'value': getLocalVar('NRORG')
				}
			];
			
			args.owner.reload();
			
		}, function(err) {
			ScreenService.showMessage(err.data.error);
		});
		
	};
	
//create filter for 'Unidades Solicitantes' fields
	this.createDsFilterUS = function (field) {
		var grup;
		if(!field.widget.currentRow.CDGRUPFILI){
			field.dataSource.name = "cmp#/crud/filial_filioper_regiao";
            field.dataSourceFilter = [
	            {
	                "name": "NRORG", 
	                "operator": "=", 
	                "value": getLocalVar('NRORG')
	            },
	            {
	                "name": "P_CDOPERADOR", 
	                "operator": "=", 
	                "value": getLocalVar('CDOPERADOR')
	            },
				{
	                "operator": "ORDER_BY",
	                "name": [
	                    {
	                        "name": "CDFILIAL",
	                        "direction": "ASC"
	                    }
	                ]
        		}
			];
		}
		else{
			grup = field.widget.currentRow.CDGRUPFILI;
			field.dataSource.name = "cmp#/crud/filial_agrup_oper";
            field.dataSourceFilter = [
	            {
	                "name": "NRORG", 
	                "operator": "=", 
	                "value": getLocalVar('NRORG')
	            },
	            {
	                "name": "CDOPERADOR", 
	                "operator": "=", 
	                "value": getLocalVar('CDOPERADOR')
	            },
	            {
	                "name": "CDGRUPFILI", 
	                "operator": "=", 
	                "value": grup
	            }
        	];
		}
		
		 field.reload();
	};
//create filter for 'Solicitação' field
	this.createDsFilter = function (field) {
		
			field.dataSourceFilter = [
				{
					'name' : 'P_CDAGRUPFILI',
					'operator': '=',
					'value': field.widget.currentRow.CDGRUPFILI
				},
				{
					'name' : 'P_CDFILSOLI',
					'operator': '=',
					'value': field.widget.currentRow.T_NMFILIAL === 'L' ? field.widget.currentRow.NMFILIAL.join('_') : null
				},
				{
					'name' : 'P_TCDFILSOLI',
					'operator': '',
					'value': field.widget.currentRow.T_NMFILIAL === 'T' ? 'T' : null
				}
			];
			field.reload();
	
	};
	
	function confirmaAlteracoes(widget) {
		var rows = widget.getCheckedRows();
		
		rows[0].SYSDATE = moment().format("DD/MM/YYYY HH:mm:ss");
		rows[0].CDOPERADOR = getLocalVar('CDOPERADOR');
		
		General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/confirmaAlteracao', 'Row', rows).then(function() {
			widget.reload();
			widget.unSelectAll();
		}).catch(function(error) {
			ScreenService.showMessage(error.data.error);
		});
		
	}
	
	
//confirm grid action
	this.confirmGridAction = function(widget){
		
		ScreenService.confirmMessage("Confirmar alteração no(s) item(ns) da(s) solicitação(ões)?", 'question',
	        function(success) {
	            confirmaAlteracoes(widget);
	        },function(error){
	           
        });
	};
	
	//set DataSourceFilter on filial filter
	this.changeGrupFili = function(widget){
		var row = widget.currentRow;
        var CDGRUPFILI;
        var FILIAL = widget.getField('NMFILIAL');
        FILIAL.clearValue();
        widget.getField('NRSOLICITA').clearValue();
        if(widget.getField('GRUPFILI').value()){
            CDGRUPFILI = row.CDGRUPFILI;
            FILIAL.dataSource.name = "cmp#/crud/filial_agrup_oper";
            FILIAL.dataSourceFilter = [
	            {
	                "name": "NRORG", 
	                "operator": "=", 
	                "value": getLocalVar('NRORG')
	            },
	            {
	                "name": "CDOPERADOR", 
	                "operator": "=", 
	                "value": getLocalVar('CDOPERADOR')
	            },
	            {
	                "name": "CDGRUPFILI", 
	                "operator": "=", 
	                "value": CDGRUPFILI
	            }
        	];
        } else { 
        	FILIAL.dataSource.name = "cmp#/crud/filial_filioper_regiao";
            row.CDGRUPFILI = '';
            FILIAL.dataSourceFilter = [
	            {
	                "name": "NRORG", 
	                "operator": "=", 
	                "value": getLocalVar('NRORG')
	            },
	            {
	                "name": "P_CDOPERADOR", 
	                "operator": "=", 
	                "value": getLocalVar('CDOPERADOR')
	            }
        	];
        }
        
       
        
        CDGRUPFILI = CDGRUPFILI === 'T' ? null : CDGRUPFILI;
        widget.getField('NRSOLICITA').dataSourceFilter = [
        	{
                "name": "CDFILIAL", 
                "operator": "=", 
                "value": 'T'
            },
            {
                "name": "P_TCDFILSOLI", 
                "operator": "=", 
                "value": 'T'
            },
            {
                "name": "CDGRUPFILI", 
                "operator": "=", 
                "value": CDGRUPFILI
            }
        ];
        
        FILIAL.reload();
        widget.getField('NRSOLICITA').reload();
	};
	this.changeFilial = function(widget){
		var row = widget.currentRow;
        var CDGRUPFILI;
        var FILIAIS;
        var P_TCDFILSOLI;
        
        if(widget.getField('GRUPFILI').value()){
            CDGRUPFILI = row.CDGRUPFILI;
        }else{
            CDGRUPFILI = null;
        }
        
        if(widget.getField('NMFILIAL').value().length){
        	FILIAIS = widget.getField('NMFILIAL').value().join('_');
        	P_TCDFILSOLI = null;
        }else{
        	FILIAIS = 'T';
        	P_TCDFILSOLI = 'T';
        	CDGRUPFILI = CDGRUPFILI === 'T' ? null : CDGRUPFILI;
        }
        
        widget.getField('NRSOLICITA').dataSourceFilter = [
        	{
                "name": "CDFILIAL", 
                "operator": "=", 
                "value": FILIAIS
            },
            {
                "name": "P_TCDFILSOLI", 
                "operator": "=", 
                "value": P_TCDFILSOLI
            },
            {
                "name": "CDGRUPFILI", 
                "operator": "=", 
                "value": CDGRUPFILI
            }
        ];
        widget.getField('NRSOLICITA').clearValue();
        widget.getField('NRSOLICITA').reload();
	};

};

Configuration(function(ContextRegister) {
    ContextRegister.register('cmp07400controle_de_alteracao_solicitacao_comprasController', cmp07400controle_de_alteracao_solicitacao_comprasController);
});